commit 11c945f26a44f4cb5c36ee1f013e7583562e7651
Author: Bernd Bleßmann <bernd@kivitendo-premium.de>
Date:   Thu Jan 29 00:14:24 2015 +0100

    Lagerbewegungs-Import: Text geändert und Schreibfehler in Übersetzung behoben.

diff --git a/SL/Controller/CsvImport/Inventory.pm b/SL/Controller/CsvImport/Inventory.pm
index b4c7c40a3..593185eb2 100644
--- a/SL/Controller/CsvImport/Inventory.pm
+++ b/SL/Controller/CsvImport/Inventory.pm
@@ -276,7 +276,7 @@ sub check_qty{
   }
 
   if (exists $entry->{raw_data}->{target_qty} && exists $entry->{raw_data}->{qty}) {
-    push @{ $entry->{errors} }, $::locale->text('Error: a quantity and a target quantity could not be given both.');
+    push @{ $entry->{errors} }, $::locale->text('Error: A quantity and a target quantity could not be given both.');
     return 0;
   }
 
diff --git a/locale/de/all b/locale/de/all
index 726bf14b7..8909686f9 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -1053,6 +1053,7 @@ $self->{texts} = {
   'Error with default taxzone'  => 'Ungültige Standardsteuerzone',
   'Error!'                      => 'Fehler!',
   'Error: A negative target quantity is not allowed.' => 'Fehler: Eine negative Zielmenge ist nicht erlaubt.',
+  'Error: A quantity and a target quantity could not be given both.' => 'Fehler: Menge und Zielmenge können nicht beide angegeben werden.',
   'Error: A quantity or a target quantity must be given.' => 'Fehler: Menge oder Zielmenge muss angegeben werden.',
   'Error: Bin not found'        => 'Fehler: Lagerplatz nicht gefunden',
   'Error: Buchungsgruppe missing or invalid' => 'Fehler: Buchungsgruppe fehlt oder ungültig',
@@ -1084,7 +1085,6 @@ $self->{texts} = {
   'Error: Transfer would result in a negative target quantity.' => 'Fehler: Lagerbewegung würde zu einer negativen Zielmenge führen.',
   'Error: Unit missing or invalid' => 'Fehler: Einheit fehlt oder ungültig',
   'Error: Warehouse not found'  => 'Fehler: Lager nicht gefunden',
-  'Error: a quantity and a target quantity could not be given both.' => 'Fehler: Menge und Zielmenge können nicht beide angegeben werden.',
   'Error: this feature requires that articles with a time-based unit (e.g. \'h\' or \'min\') exist.' => 'Fehler: dieses Feature setzt voraus, dass Artikel mit einer Zeit-basierenden Einheit (z.B. "Std") existieren.',
   'Errors'                      => 'Fehler',
   'Ertrag'                      => 'Ertrag',
@@ -1697,7 +1697,7 @@ $self->{texts} = {
   'On'                          => 'An',
   'On Hand'                     => 'Auf Lager',
   'On Order'                    => 'Ist bestellt',
-  'One of the columns "qty" or "target_qty" must be given. If "target_qty" is given, the quantity to transfer for each transfer will be calculate, so that the quantity for this part, warehouse and bin will result in the given "target_qty" after each transfer.' => 'Eine der Spalten "qty" oder "target_qty" muss angegeben werden. Wird "target_qty" angegeben, so wird die zu bewegende Menge für jede Lagerbewegung so berechnet, dass die Lagermenge für diesen Artikel, Lager und Lagerplatz nach jeder Lagerbewegung der angebenen Zielmenge entspricht.',
+  'One of the columns "qty" or "target_qty" must be given. If "target_qty" is given, the quantity to transfer for each transfer will be calculate, so that the quantity for this part, warehouse and bin will result in the given "target_qty" after each transfer.' => 'Eine der Spalten "qty" oder "target_qty" muss angegeben werden. Wird "target_qty" angegeben, so wird die zu bewegende Menge für jede Lagerbewegung so berechnet, dass die Lagermenge für diesen Artikel, Lager und Lagerplatz nach jeder Lagerbewegung der angegebenen Zielmenge entspricht.',
   'One or more Perl modules missing' => 'Ein oder mehr Perl-Module fehlen',
   'Onhand only sets the quantity in master data, not in inventory. This is only a legacy info field and will be overwritten as soon as a inventory transfer happens.' => 'Das Import-Feld Auf Lager setzt nur die Menge in den Stammdaten, nicht im Lagerbereich. Dies ist historisch gewachsen nur ein Informationsfeld was mit dem tatsächlichen Wert überschrieben wird, sobald eine wirkliche Lagerbewegung stattfindet (DB-Trigger).',
   'Only Warnings and Errors'    => 'Nur Warnungen und Fehler',
diff --git a/locale/en/all b/locale/en/all
index fca8ec00f..223d4be96 100644
--- a/locale/en/all
+++ b/locale/en/all
@@ -891,6 +891,7 @@ $self->{texts} = {
   'Error when saving: #1'       => '',
   'Error!'                      => '',
   'Error: A negative target quantity is not allowed.' => '',
+  'Error: A quantity and a target quantity could not be given both.' => '',
   'Error: A quantity or a target quantity must be given.' => '',
   'Error: Bin not found'        => '',
   'Error: Buchungsgruppe missing or invalid' => '',
@@ -922,7 +923,6 @@ $self->{texts} = {
   'Error: Transfer would result in a negative target quantity.' => '',
   'Error: Unit missing or invalid' => '',
   'Error: Warehouse not found'  => '',
-  'Error: a quantity and a target quantity could not be given both.' => '',
   'Errors'                      => '',
   'Ertrag'                      => '',
   'Ertrag prozentual'           => '',