commit 2e18decc8e5994b7682fb2dbd1211f9252ea8667
Author: Hans Peter Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Fri Jan 4 06:21:23 2019 +0100

    Design 4.0: Kosmetik in templates/webpages/rp/..: TT-Tags geändert

diff --git a/templates/webpages/rp/html_report_susa.html b/templates/webpages/rp/html_report_susa.html
index a075c62a5..c88fdccaf 100644
--- a/templates/webpages/rp/html_report_susa.html
+++ b/templates/webpages/rp/html_report_susa.html
@@ -61,25 +61,25 @@
      [% IF row.IS_COLSPAN_DATA %]<tr><td colspan="[% row.NUM_COLUMNS %]">[% row.data %]</td></tr>[% END %]
      [% ELSE %]
      <tr class="listrow[% row.outer_idx_odd %]">
-      [%- FOREACH col = row.COLUMNS %]
+      [% FOREACH col = row.COLUMNS %]
       <td[% IF col.align %] align="[% col.align %]"[% END %]
-         [%- IF col.valign %] valign="[% col.valign %]"[%- END %]
-         [%- SET tdclass = '' %]
-         [%- IF row.BORDER_TOP %][%- SET tdclass = "$tdclass top_border" %][%- END %]
-         [%- IF row.BORDER_BOTTOM %][%- SET tdclass = "$tdclass bottom_border" %][%- END %]
-         [%- IF col.class %][%- SET tdclass = "$tdclass $col.class" %][%- END %]
-         [%- IF tdclass %] class="[% tdclass %]"[%- END %]>
-       [%- IF col.raw_data %][%- col.raw_data %][%- END %]
-       [%- USE iterator(col.CELL_ROWS) %][%- FOREACH cell_row = iterator %]
-        [%- IF cell_row.data != '' %]
-         [%- IF cell_row.link %]<a href="[% cell_row.link %]">[%- END %]
-         [%- cell_row.data %]
-         [%- IF cell_row.link %]</a>[%- END %]
-        [%- END %]
-       [%- UNLESS iterator.last %]<br>[%- END %]
-       [%- END %]
+         [% IF col.valign %] valign="[% col.valign %]"[% END %]
+         [% SET tdclass = '' %]
+         [% IF row.BORDER_TOP %][% SET tdclass = "$tdclass top_border" %][% END %]
+         [% IF row.BORDER_BOTTOM %][% SET tdclass = "$tdclass bottom_border" %][% END %]
+         [% IF col.class %][% SET tdclass = "$tdclass $col.class" %][% END %]
+         [% IF tdclass %] class="[% tdclass %]"[% END %]>
+       [% IF col.raw_data %][% col.raw_data %][% END %]
+       [% USE iterator(col.CELL_ROWS) %][% FOREACH cell_row = iterator %]
+        [% IF cell_row.data != '' %]
+         [% IF cell_row.link %]<a href="[% cell_row.link %]">[% END %]
+         [% cell_row.data %]
+         [% IF cell_row.link %]</a>[% END %]
+        [% END %]
+       [% UNLESS iterator.last %]<br>[% END %]
+       [% END %]
       </td>
-      [%- END %]
+      [% END %]
      </tr>
     [% END %]
    [% END %]
diff --git a/templates/webpages/rp/report.html b/templates/webpages/rp/report.html
index 596dc8827..4277d219f 100644
--- a/templates/webpages/rp/report.html
+++ b/templates/webpages/rp/report.html
@@ -4,7 +4,7 @@
 [% USE P %]
 [% USE T8 %]
 
-[%- BLOCK customized_report %]
+[% BLOCK customized_report %]
   <tr>
     <th align=left><input name=reporttype class=radio type=radio value="custom" checked>[% 'Customized Report' | $T8 %]</th>
   </tr>
@@ -103,14 +103,14 @@
       [% L.radio_button_tag('method', value='cash', checked=(INSTANCE_CONF.get_accounting_method=='cash'), label=LxERP.t8('cash')) %]
     </td>
   </tr>
-[%- END %]
-[%- BLOCK customer %]
+[% END   #BLOCK cash_or_accrual %]
+[% BLOCK customer %]
   <tr>
     <th align=right nowrap>[% 'Customer' | $T8 %]</th>
     <td colspan=3>[% P.customer_vendor.picker('customer_id', '', type='customer') %]</td>
   </tr>
-[%- END %]
-[%- BLOCK projectnumber %]
+[% END   #BLOCK customer %]
+[% BLOCK projectnumber %]
   <tr>
     <th align=right nowrap>[% 'Project' | $T8 %]</th>
     <td colspan=3>[% P.project.picker('project_id', '') %]</td>
diff --git a/templates/webpages/rp/tax_report.html b/templates/webpages/rp/tax_report.html
index d5cc94318..093b87e35 100644
--- a/templates/webpages/rp/tax_report.html
+++ b/templates/webpages/rp/tax_report.html
@@ -7,9 +7,9 @@
   <tr class='[% class %]'>
   [% FOREACH col IN column_index %]
     <td class='[% class %] numeric'>
-      [%- SWITCH col %]
-      [%- CASE [ 'netamount', 'tax', 'amount' ] %][% LxERP.format_amount(row.$col, 2) %]
-      [%- CASE %]&nbsp;[% END %]
+      [% SWITCH col %]
+      [% CASE [ 'netamount', 'tax', 'amount' ] %][% LxERP.format_amount(row.$col, 2) %]
+      [% CASE %]&nbsp;[% END %]
     </td>
   [% END %]
   </tr>